module Ta = 
struct

type color = R | B;;

let rec id x = (fun xa -> xa) x;;

type 'a eq = {eq : 'a -> 'a -> bool};;
let eq _A = _A.eq;;

type ('a, 'b) rbt = Empty |
  Tr of color * ('a, 'b) rbt * 'a * 'b * ('a, 'b) rbt;;

type ('a, 'b) ta_rule = Rule of 'a * 'b * 'a list;;

let rec lhs (Rule (q, l, qs)) = q;;

let rec eqa _A a b = eq _A a b;;

let rec leta s f = f s;;

type 'a ord = {less_eq : 'a -> 'a -> bool; less : 'a -> 'a -> bool};;
let less_eq _A = _A.less_eq;;
let less _A = _A.less;;

let rec hd (x :: xs) = x;;

let rec tl = function [] -> []
             | x :: xs -> xs;;

let rec suc n = Big_int.add_big_int n (Big_int.big_int_of_int 1);;

let rec balance
  x0 s t x3 = match x0, s, t, x3 with
    Tr (R, a, w, x, b), s, t, Tr (R, c, y, z, d) ->
      Tr (R, Tr (B, a, w, x, b), s, t, Tr (B, c, y, z, d))
    | Tr (R, Tr (R, a, w, x, b), s, t, c), y, z, Empty ->
        Tr (R, Tr (B, a, w, x, b), s, t, Tr (B, c, y, z, Empty))
    | Tr (R, Tr (R, a, w, x, b), s, t, c), y, z, Tr (B, va, vb, vc, vd) ->
        Tr (R, Tr (B, a, w, x, b), s, t,
             Tr (B, c, y, z, Tr (B, va, vb, vc, vd)))
    | Tr (R, Empty, w, x, Tr (R, b, s, t, c)), y, z, Empty ->
        Tr (R, Tr (B, Empty, w, x, b), s, t, Tr (B, c, y, z, Empty))
    | Tr (R, Tr (B, va, vb, vc, vd), w, x, Tr (R, b, s, t, c)), y, z, Empty ->
        Tr (R, Tr (B, Tr (B, va, vb, vc, vd), w, x, b), s, t,
             Tr (B, c, y, z, Empty))
    | Tr (R, Empty, w, x, Tr (R, b, s, t, c)), y, z, Tr (B, va, vb, vc, vd) ->
        Tr (R, Tr (B, Empty, w, x, b), s, t,
             Tr (B, c, y, z, Tr (B, va, vb, vc, vd)))
    | Tr (R, Tr (B, ve, vf, vg, vh), w, x, Tr (R, b, s, t, c)), y, z,
        Tr (B, va, vb, vc, vd)
        -> Tr (R, Tr (B, Tr (B, ve, vf, vg, vh), w, x, b), s, t,
                Tr (B, c, y, z, Tr (B, va, vb, vc, vd)))
    | Empty, w, x, Tr (R, b, s, t, Tr (R, c, y, z, d)) ->
        Tr (R, Tr (B, Empty, w, x, b), s, t, Tr (B, c, y, z, d))
    | Tr (B, va, vb, vc, vd), w, x, Tr (R, b, s, t, Tr (R, c, y, z, d)) ->
        Tr (R, Tr (B, Tr (B, va, vb, vc, vd), w, x, b), s, t,
             Tr (B, c, y, z, d))
    | Empty, w, x, Tr (R, Tr (R, b, s, t, c), y, z, Empty) ->
        Tr (R, Tr (B, Empty, w, x, b), s, t, Tr (B, c, y, z, Empty))
    | Empty, w, x, Tr (R, Tr (R, b, s, t, c), y, z, Tr (B, va, vb, vc, vd)) ->
        Tr (R, Tr (B, Empty, w, x, b), s, t,
             Tr (B, c, y, z, Tr (B, va, vb, vc, vd)))
    | Tr (B, va, vb, vc, vd), w, x, Tr (R, Tr (R, b, s, t, c), y, z, Empty) ->
        Tr (R, Tr (B, Tr (B, va, vb, vc, vd), w, x, b), s, t,
             Tr (B, c, y, z, Empty))
    | Tr (B, va, vb, vc, vd), w, x,
        Tr (R, Tr (R, b, s, t, c), y, z, Tr (B, ve, vf, vg, vh))
        -> Tr (R, Tr (B, Tr (B, va, vb, vc, vd), w, x, b), s, t,
                Tr (B, c, y, z, Tr (B, ve, vf, vg, vh)))
    | Empty, s, t, Empty -> Tr (B, Empty, s, t, Empty)
    | Empty, s, t, Tr (B, va, vb, vc, vd) ->
        Tr (B, Empty, s, t, Tr (B, va, vb, vc, vd))
    | Empty, s, t, Tr (B, va, vb, vc, Empty) ->
        Tr (B, Empty, s, t, Tr (B, va, vb, vc, Empty))
    | Empty, s, t, Tr (v, Empty, vb, vc, Empty) ->
        Tr (B, Empty, s, t, Tr (v, Empty, vb, vc, Empty))
    | Empty, s, t, Tr (v, Tr (B, ve, vf, vg, vh), vb, vc, Empty) ->
        Tr (B, Empty, s, t, Tr (v, Tr (B, ve, vf, vg, vh), vb, vc, Empty))
    | Empty, s, t, Tr (B, va, vb, vc, Tr (B, vf, vg, vh, vi)) ->
        Tr (B, Empty, s, t, Tr (B, va, vb, vc, Tr (B, vf, vg, vh, vi)))
    | Empty, s, t, Tr (v, Empty, vb, vc, Tr (B, vf, vg, vh, vi)) ->
        Tr (B, Empty, s, t, Tr (v, Empty, vb, vc, Tr (B, vf, vg, vh, vi)))
    | Empty, s, t,
        Tr (v, Tr (B, ve, vj, vk, vl), vb, vc, Tr (B, vf, vg, vh, vi))
        -> Tr (B, Empty, s, t,
                Tr (v, Tr (B, ve, vj, vk, vl), vb, vc, Tr (B, vf, vg, vh, vi)))
    | Tr (B, va, vb, vc, vd), s, t, Empty ->
        Tr (B, Tr (B, va, vb, vc, vd), s, t, Empty)
    | Tr (B, va, vb, vc, vd), s, t, Tr (B, ve, vf, vg, vh) ->
        Tr (B, Tr (B, va, vb, vc, vd), s, t, Tr (B, ve, vf, vg, vh))
    | Tr (B, va, vb, vc, vd), s, t, Tr (B, ve, vf, vg, Empty) ->
        Tr (B, Tr (B, va, vb, vc, vd), s, t, Tr (B, ve, vf, vg, Empty))
    | Tr (B, va, vb, vc, vd), s, t, Tr (v, Empty, vf, vg, Empty) ->
        Tr (B, Tr (B, va, vb, vc, vd), s, t, Tr (v, Empty, vf, vg, Empty))
    | Tr (B, va, vb, vc, vd), s, t,
        Tr (v, Tr (B, vi, vj, vk, vl), vf, vg, Empty)
        -> Tr (B, Tr (B, va, vb, vc, vd), s, t,
                Tr (v, Tr (B, vi, vj, vk, vl), vf, vg, Empty))
    | Tr (B, va, vb, vc, vd), s, t, Tr (B, ve, vf, vg, Tr (B, vj, vk, vl, vm))
        -> Tr (B, Tr (B, va, vb, vc, vd), s, t,
                Tr (B, ve, vf, vg, Tr (B, vj, vk, vl, vm)))
    | Tr (B, va, vb, vc, vd), s, t,
        Tr (v, Empty, vf, vg, Tr (B, vj, vk, vl, vm))
        -> Tr (B, Tr (B, va, vb, vc, vd), s, t,
                Tr (v, Empty, vf, vg, Tr (B, vj, vk, vl, vm)))
    | Tr (B, va, vb, vc, vd), s, t,
        Tr (v, Tr (B, vi, vn, vo, vp), vf, vg, Tr (B, vj, vk, vl, vm))
        -> Tr (B, Tr (B, va, vb, vc, vd), s, t,
                Tr (v, Tr (B, vi, vn, vo, vp), vf, vg, Tr (B, vj, vk, vl, vm)))
    | Empty, s, t, Empty -> Tr (B, Empty, s, t, Empty)
    | Tr (B, va, vb, vc, vd), s, t, Empty ->
        Tr (B, Tr (B, va, vb, vc, vd), s, t, Empty)
    | Tr (B, Empty, vb, vc, vd), s, t, Empty ->
        Tr (B, Tr (B, Empty, vb, vc, vd), s, t, Empty)
    | Tr (v, Empty, vb, vc, Empty), s, t, Empty ->
        Tr (B, Tr (v, Empty, vb, vc, Empty), s, t, Empty)
    | Tr (v, Empty, vb, vc, Tr (B, ve, vf, vg, vh)), s, t, Empty ->
        Tr (B, Tr (v, Empty, vb, vc, Tr (B, ve, vf, vg, vh)), s, t, Empty)
    | Tr (B, Tr (B, vf, vg, vh, vi), vb, vc, vd), s, t, Empty ->
        Tr (B, Tr (B, Tr (B, vf, vg, vh, vi), vb, vc, vd), s, t, Empty)
    | Tr (v, Tr (B, vf, vg, vh, vi), vb, vc, Empty), s, t, Empty ->
        Tr (B, Tr (v, Tr (B, vf, vg, vh, vi), vb, vc, Empty), s, t, Empty)
    | Tr (v, Tr (B, vf, vg, vh, vi), vb, vc, Tr (B, ve, vj, vk, vl)), s, t,
        Empty
        -> Tr (B, Tr (v, Tr (B, vf, vg, vh, vi), vb, vc,
                       Tr (B, ve, vj, vk, vl)),
                s, t, Empty)
    | Empty, s, t, Tr (B, va, vb, vc, vd) ->
        Tr (B, Empty, s, t, Tr (B, va, vb, vc, vd))
    | Tr (B, ve, vf, vg, vh), s, t, Tr (B, va, vb, vc, vd) ->
        Tr (B, Tr (B, ve, vf, vg, vh), s, t, Tr (B, va, vb, vc, vd))
    | Tr (B, Empty, vf, vg, vh), s, t, Tr (B, va, vb, vc, vd) ->
        Tr (B, Tr (B, Empty, vf, vg, vh), s, t, Tr (B, va, vb, vc, vd))
    | Tr (v, Empty, vf, vg, Empty), s, t, Tr (B, va, vb, vc, vd) ->
        Tr (B, Tr (v, Empty, vf, vg, Empty), s, t, Tr (B, va, vb, vc, vd))
    | Tr (v, Empty, vf, vg, Tr (B, vi, vj, vk, vl)), s, t,
        Tr (B, va, vb, vc, vd)
        -> Tr (B, Tr (v, Empty, vf, vg, Tr (B, vi, vj, vk, vl)), s, t,
                Tr (B, va, vb, vc, vd))
    | Tr (B, Tr (B, vj, vk, vl, vm), vf, vg, vh), s, t, Tr (B, va, vb, vc, vd)
        -> Tr (B, Tr (B, Tr (B, vj, vk, vl, vm), vf, vg, vh), s, t,
                Tr (B, va, vb, vc, vd))
    | Tr (v, Tr (B, vj, vk, vl, vm), vf, vg, Empty), s, t,
        Tr (B, va, vb, vc, vd)
        -> Tr (B, Tr (v, Tr (B, vj, vk, vl, vm), vf, vg, Empty), s, t,
                Tr (B, va, vb, vc, vd))
    | Tr (v, Tr (B, vj, vk, vl, vm), vf, vg, Tr (B, vi, vn, vo, vp)), s, t,
        Tr (B, va, vb, vc, vd)
        -> Tr (B, Tr (v, Tr (B, vj, vk, vl, vm), vf, vg,
                       Tr (B, vi, vn, vo, vp)),
                s, t, Tr (B, va, vb, vc, vd));;

type 'a preorder = {ord_preorder : 'a ord};;

type 'a order = {preorder_order : 'a preorder};;

type 'a linorder = {order_linorder : 'a order};;

let rec ins _A
  f k v x3 = match f, k, v, x3 with f, k, v, Empty -> Tr (R, Empty, k, v, Empty)
    | f, k, v, Tr (B, l, x, y, r) ->
        (if less _A.order_linorder.preorder_order.ord_preorder k x
          then balance (ins _A f k v l) x y r
          else (if less _A.order_linorder.preorder_order.ord_preorder x k
                 then balance l x y (ins _A f k v r)
                 else Tr (B, l, x, f k y v, r)))
    | f, k, v, Tr (R, l, x, y, r) ->
        (if less _A.order_linorder.preorder_order.ord_preorder k x
          then Tr (R, ins _A f k v l, x, y, r)
          else (if less _A.order_linorder.preorder_order.ord_preorder x k
                 then Tr (R, l, x, y, ins _A f k v r)
                 else Tr (R, l, x, f k y v, r)));;

let rec rhsl (Rule (q, l, qs)) = l;;

let rec rhsq (Rule (q, l, qs)) = qs;;

type ('a, 'b) ustate_wrapper = USW1 of 'a | USW2 of 'b;;

let rec comp f g = (fun x -> f (g x));;

let rec map
  f x1 = match f, x1 with f, [] -> []
    | f, x :: xs -> f x :: map f xs;;

let rec foldl
  f a x2 = match f, a, x2 with f, a, [] -> a
    | f, a, x :: xs -> foldl f (f a x) xs;;

let rec rev xs = foldl (fun xsa x -> x :: xsa) [] xs;;

let rec list_case
  f1 f2 x2 = match f1, f2, x2 with f1, f2, a :: lista -> f2 a lista
    | f1, f2, [] -> f1;;

let rec zip
  xs x1 = match xs, x1 with xs, [] -> []
    | xs, y :: ys -> (match xs with [] -> [] | z :: zs -> (z, y) :: zip zs ys);;

type 'a tree = Node of 'a * 'a tree list;;

let rec null = function [] -> true
               | x :: xs -> false;;

let rec revg
  x0 b = match x0, b with [], b -> b
    | a :: asa, b -> revg asa (a :: b);;

let eq_nat = ({eq = Big_int.eq_big_int} : Big_int.big_int eq);;

let rec paint
  c x1 = match c, x1 with c, Empty -> Empty
    | c, Tr (uu, l, k, v, r) -> Tr (c, l, k, v, r);;

let rec insertwithkey _A f k v t = paint B (ins _A f k v t);;

let rec insrt _A k v t = insertwithkey _A (fun _ _ nv -> nv) k v t;;

let rec r_prod
  (Rule (q1, l1, qs1)) (Rule (q2, l2, qs2)) = Rule ((q1, q2), l1, zip qs1 qs2);;

let ord_int =
  ({less_eq = Big_int.le_big_int; less = Big_int.lt_big_int} :
    Big_int.big_int ord);;

let rec map_of _A
  x0 k = match x0, k with
    (l, v) :: ps, k -> (if eqa _A l k then Some v else map_of _A ps k)
    | [], k -> None;;

let rec the (Some x) = x;;

let rec map_ofa _A
  x0 k = match x0, k with Empty, k -> None
    | Tr (uu, l, x, y, r), k ->
        (if less _A.order_linorder.preorder_order.ord_preorder k x
          then map_ofa _A l k
          else (if less _A.order_linorder.preorder_order.ord_preorder x k
                 then map_ofa _A r k else Some y));;

let rec inj_image_filter_cp
  iterate1 iterate2 empty3 insert_dj3 f p s1 s2 =
    iterate1
      (fun x ->
        iterate2 (fun y res -> (if p x y then insert_dj3 (f x y) res else res))
          s2)
      s1
      empty3;;

let rec cart
  it1 it2 empty3 ins3 s1 s2 =
    inj_image_filter_cp it1 it2 empty3 ins3 (fun a b -> (a, b))
      (fun _ _ -> true) s1 s2;;

let rec eq_list _A
  x0 x1 = match x0, x1 with [], [] -> true
    | a :: lista, a' :: list' -> eqa _A a a' && eq_list _A lista list'
    | [], a' :: list' -> false
    | a' :: list', [] -> false;;

let rec eq_lista _A = ({eq = eq_list _A} : ('a list) eq);;

let rec member _A
  x xa1 = match x, xa1 with x, [] -> false
    | x, y :: ys -> eqa _A x y || member _A x ys;;

type ('a, 'b, 'c) tuple_isomorphism =
  TupleIsomorphism of ('a -> 'b * 'c) * ('b * 'c -> 'a);;

let rec abst (TupleIsomorphism (r, a)) = a;;

let rec repr (TupleIsomorphism (r, a)) = r;;

let preorder_int = ({ord_preorder = ord_int} : Big_int.big_int preorder);;

let order_int = ({preorder_order = preorder_int} : Big_int.big_int order);;

let rec remdups _A
  = function [] -> []
    | x :: xs ->
        (if member _A x xs then remdups _A xs else x :: remdups _A xs);;

let rec it_add update iterate m1 m2 = iterate update m2 m1;;

let rec eq_ta_rule _A _B
  (Rule (q, l, lista)) (Rule (q', l', list')) =
    eqa _A q q' && (eqa _B l l' && eq_list _A lista list');;

let rec eq_ta_rulea _A _B = ({eq = eq_ta_rule _A _B} : ('a, 'b) ta_rule eq);;

let rec snd (a, b) = b;;

let rec fst (a, b) = a;;

let rec fifo_get
  f = (match snd f with [] -> let rp = rev (fst f) in
                              (hd rp, ([], tl rp))
        | a :: l -> (a, (fst f, l)));;

let rec fifo_put a f = (a :: fst f, snd f);;

let rec list_all
  p x1 = match p, x1 with p, [] -> true
    | p, x :: xs -> p x && list_all p xs;;

let rec is_none = function Some x -> false
                  | None -> true;;

let rec iti_sel iti m f = iti is_none (fun k v _ -> f k v) m None;;

let rec map_sng empt update k v = update k v empt;;

let rec minus_nat
  n m = Big_int.max_big_int Big_int.zero_big_int (Big_int.sub_big_int n m);;

let rec it_size
  iterate s = iterate (fun _ -> suc) s (Big_int.big_int_of_int 0);;

let rec remap_rule f (Rule (q, l, qs)) = Rule (f q, l, map f qs);;

let linorder_int = ({order_linorder = order_int} : Big_int.big_int linorder);;

let rec lm_iterate_code
  f x1 sigma = match f, x1, sigma with f, [], sigma -> sigma
    | f, (k, v) :: l, sigma -> lm_iterate_code f l (f k v sigma);;

let rec lm_iterate x = lm_iterate_code x;;

let rec foldwithkey _A
  f x1 v = match f, x1, v with f, Empty, v -> v
    | f, Tr (c, lt, k, x, rt), v ->
        foldwithkey _A f rt (f k x (foldwithkey _A f lt v));;

let rec rm_iterate _A f t sigma_0 = foldwithkey _A f t sigma_0;;

let rec hm_iterate _D
  f m sigma_0 = rm_iterate _D (fun _ -> lm_iterate f) m sigma_0;;

let rec rm_lookup _A k m = map_ofa _A m k;;

let rec update _A
  k v x2 = match k, v, x2 with k, v, [] -> [(k, v)]
    | k, v, p :: ps ->
        (if eqa _A (fst p) k then (k, v) :: ps else p :: update _A k v ps);;

let rec lm_update _A = update _A;;

let lm_empty : 'a list = [];;

let rec lm_sng _A = map_sng lm_empty (lm_update _A);;

let rec rm_update _A = insrt _A;;

let rec option_case
  f1 f2 x2 = match f1, f2, x2 with f1, f2, Some a -> f2 a
    | f1, f2, None -> f1;;

type 'a hashable = {hashcode : 'a -> Big_int.big_int};;
let hashcode _A = _A.hashcode;;

let rec hm_update (_A1, _A2)
  k v m =
    let hc = hashcode _A2 k in
    (match rm_lookup linorder_int hc m
      with None -> rm_update linorder_int hc (lm_sng _A1 k v) m
      | Some bm -> rm_update linorder_int hc (lm_update _A1 k v bm) m);;

let rec hm_add (_A1, _A2)
  = it_add (hm_update (_A1, _A2)) (hm_iterate linorder_int);;

let rec lm_iteratei
  c f x2 sigma = match c, f, x2, sigma with c, f, [], sigma -> sigma
    | c, f, (k, v) :: l, sigma ->
        (if c sigma then lm_iteratei c f l (f k v sigma) else sigma);;

let rec lm_sel x = iti_sel lm_iteratei x;;

let rec rm_iteratei
  c f x2 sigma = match c, f, x2, sigma with c, f, Empty, sigma -> sigma
    | c, f, Tr (col, l, k, v, r), sigma ->
        (if c sigma then rm_iteratei c f l (rm_iteratei c f r (f k v sigma))
          else sigma);;

let rec rm_sel x = iti_sel rm_iteratei x;;

let rec hm_sel _A m f = rm_sel m (fun _ lm -> lm_sel lm f);;

let rec s_ins update x s = update x () s;;

let rec hs_ins (_A1, _A2) = s_ins (hm_update (_A1, _A2));;

let rec s_sel sel s f = sel s (fun u _ -> f u);;

let rec hs_sel _A = s_sel (hm_sel _A);;

let rec size_list
  = function [] -> (Big_int.big_int_of_int 0)
    | a :: lista ->
        Big_int.add_big_int (size_list lista) (suc (Big_int.big_int_of_int 0));;

let rec eqb _A _B (x1, y1) (x2, y2) = eqa _A x1 x2 && eqa _B y1 y2;;

let rec eqc _A _B = ({eq = eqb _A _B} : ('a * 'b) eq);;

let rec it_inter
  iterate1 memb2 empt3 insrt3 s1 s2 =
    iterate1 (fun x s -> (if memb2 x s2 then insrt3 x s else s)) s1 empt3;;

let rec it_union iterate1 insrt2 s1 s2 = iterate1 insrt2 s1 s2;;

let rm_empty : ('a, 'b) rbt = Empty;;

let hm_empty : ('a, 'b) rbt = rm_empty;;

let rec s_empty empt = empt;;

let rec hs_empty _A = s_empty hm_empty;;

let rec ls_iteratei
  c f x2 sigma = match c, f, x2, sigma with c, f, [], sigma -> sigma
    | c, f, x :: l, sigma ->
        (if c sigma then ls_iteratei c f l (f x sigma) else sigma);;

let rec iti_iterate iti = iti (fun _ -> true);;

let rec ls_iterate x = iti_iterate ls_iteratei x;;

let rec it_image_filter
  iterate1 empty2 ins2 f s =
    iterate1 (fun x res -> (match f x with None -> res | Some v -> ins2 v res))
      s
      empty2;;

let rec lh_image_filter (_B1, _B2)
  = it_image_filter ls_iterate (hs_empty _B2) (hs_ins (_B1, _B2));;

let rec brc_iq (_A1, _A2)
  delta =
    lh_image_filter (_A1, _A2)
      (fun r -> (if null (rhsq r) then Some (lhs r) else None)) delta;;

type ('a, 'b, 'c) hashedTa_ext_type =
  Abs_hashedTa_ext_type of
    ((((Big_int.big_int, (('a * unit) list)) rbt * ('a, 'b) ta_rule list) *
       ((Big_int.big_int, (('b * ('a, 'b) ta_rule list) list)) rbt option *
         ((Big_int.big_int, (('a * ('a, 'b) ta_rule list) list)) rbt option *
           (Big_int.big_int, ((('a * 'b) * ('a, 'b) ta_rule list) list))
             rbt option)))
      * 'c);;

let rec rep_hashedTa_ext_type (Abs_hashedTa_ext_type y) = y;;

let hashedTa_ext_type_TupleIsom :
  (('a, 'b, 'c) hashedTa_ext_type,
    (((Big_int.big_int, (('a * unit) list)) rbt * ('a, 'b) ta_rule list) *
      ((Big_int.big_int, (('b * ('a, 'b) ta_rule list) list)) rbt option *
        ((Big_int.big_int, (('a * ('a, 'b) ta_rule list) list)) rbt option *
          (Big_int.big_int, ((('a * 'b) * ('a, 'b) ta_rule list) list))
            rbt option))),
    'c)
    tuple_isomorphism
  = TupleIsomorphism
      (rep_hashedTa_ext_type, (fun a -> Abs_hashedTa_ext_type a));;

let rec istuple_snd isom = comp snd (repr isom);;

let tuple_istuple : (('a * 'b), 'a, 'b) tuple_isomorphism
  = TupleIsomorphism (id, id);;

let rec istuple_fst isom = comp fst (repr isom);;

let rec hta_idx_f
  x = comp (comp (comp id (istuple_fst tuple_istuple))
             (istuple_snd tuple_istuple))
        (istuple_fst hashedTa_ext_type_TupleIsom) x;;

let ls_empty : 'a list = [];;

let rec lm_lookup _A k m = map_of _A m k;;

let rec hm_lookup (_A1, _A2)
  k m = (match rm_lookup linorder_int (hashcode _A2 k) m with None -> None
          | Some a -> lm_lookup _A1 k a);;

let rec idx_lookup
  mlookup tempty i m = (match mlookup i m with None -> tempty | Some s -> s);;

let rec hl_idx_lookup (_A1, _A2) = idx_lookup (hm_lookup (_A1, _A2)) ls_empty;;

let rec hta_lookup_f (_A1, _A2)
  f h = hl_idx_lookup (_A1, _A2) f (the (hta_idx_f h));;

let rec ls_memb _A = member _A;;

let rec list_all_zip
  p x1 x2 = match p, x1, x2 with p, [], [] -> true
    | p, a :: asa, b :: bs -> p a b && list_all_zip p asa bs
    | p, v :: va, [] -> false
    | p, [], v :: va -> false;;

let rec ta_rule_case f1 (Rule (q, l, lista)) = f1 q l lista;;

let rec ls_ins _A x l = (if member _A x l then l else x :: l);;

let rec ls_image_filter _B = it_image_filter ls_iterate ls_empty (ls_ins _B);;

let rec faccs' _A (_B1, _B2)
  h (Node (f, ts)) =
    let qs = map (faccs' _A (_B1, _B2) h) ts in
    ls_image_filter _A
      (fun r ->
        let Rule (_, _, qsa) = r in
        (if list_all_zip (fun q qa -> ls_memb _A qa q) qs qsa then Some (lhs r)
          else None))
      (hta_lookup_f (_B1, _B2) f h);;

let rec hta_Qi
  x = comp (comp (comp id (istuple_fst tuple_istuple))
             (istuple_fst tuple_istuple))
        (istuple_fst hashedTa_ext_type_TupleIsom) x;;

let fifo_empty : 'a list * 'a list = ([], []);;

let rec s_memb lookup x s = not (is_none (lookup x s));;

let rec hs_memb (_A1, _A2) = s_memb (hm_lookup (_A1, _A2));;

let rec s_iterate iterate f s sigma_0 = iterate (fun k _ -> f k) s sigma_0;;

let rec hs_iterate _A = s_iterate (hm_iterate linorder_int);;

let rec hs_size _A = it_size (hs_iterate _A);;

let rec hta_delta
  x = comp (comp (comp id (istuple_snd tuple_istuple))
             (istuple_fst tuple_istuple))
        (istuple_fst hashedTa_ext_type_TupleIsom) x;;

let rec idx_build_stepfun
  mlookup mupdate tempty tinsert f x m =
    let i = f x in
    (match mlookup i m with None -> mupdate i (tinsert x tempty) m
      | Some s -> mupdate i (tinsert x s) m);;

let rec idx_build
  mempty mlookup mupdate tempty tinsert siterate f s =
    siterate (idx_build_stepfun mlookup mupdate tempty tinsert f) s mempty;;

let rec hll_idx_build _A (_B1, _B2)
  = idx_build hm_empty (hm_lookup (_B1, _B2)) (hm_update (_B1, _B2)) ls_empty
      (ls_ins _A) ls_iterate;;

let rec build_rule_index _A _B (_C1, _C2)
  = hll_idx_build (eq_ta_rulea _A _B) (_C1, _C2);;

let rec build_rule_index_f _A (_B1, _B2)
  delta = build_rule_index _A _B1 (_B1, _B2) rhsl delta;;

let rec apsnd f (x, y) = (x, f y);;

let rec istuple_snd_update
  isom f = comp (comp (abst isom) (apsnd f)) (repr isom);;

let rec apfst f (x, y) = (f x, y);;

let rec istuple_fst_update
  isom f = comp (comp (abst isom) (apfst f)) (repr isom);;

let rec hta_idx_f_update
  x = comp (istuple_fst_update hashedTa_ext_type_TupleIsom)
        (comp (istuple_snd_update tuple_istuple)
          (comp (istuple_fst_update tuple_istuple) id))
        x;;

let rec hta_ensure_idx_f _A (_B1, _B2)
  h = (match hta_idx_f h
        with None ->
          hta_idx_f_update
            (fun _ -> Some (build_rule_index_f _A (_B1, _B2) (hta_delta h))) h
        | Some _ -> h);;

let rec ls_ball l p = list_all p l;;

let rec ball_disjoint ball1 memb2 s1 s2 = ball1 s1 (fun x -> not (memb2 x s2));;

let rec lh_disjoint (_A1, _A2) = ball_disjoint ls_ball (hs_memb (_A1, _A2));;

let rec hta_mem' (_A1, _A2) (_B1, _B2)
  t h = not (lh_disjoint (_B1, _B2) (faccs' _B1 (_A1, _A2) h t) (hta_Qi h));;

let rec hta_mem (_A1, _A2) (_B1, _B2)
  t h = hta_mem' (_A1, _A2) (_B1, _B2) t (hta_ensure_idx_f _B1 (_A1, _A2) h);;

let rec split f (a, b) = f a b;;

let rec pa_cond _A _B _C s = let (_, (w, _)) = s in
                             not (null w);;

let rec hta_idx_s
  x = comp (comp (comp (comp id (istuple_fst tuple_istuple))
                   (istuple_snd tuple_istuple))
             (istuple_snd tuple_istuple))
        (istuple_fst hashedTa_ext_type_TupleIsom) x;;

let rec hta_lookup_s (_A1, _A2)
  q h = hl_idx_lookup (_A1, _A2) q (the (hta_idx_s h));;

let rec hta_idx_sf
  x = comp (comp (comp (comp id (istuple_snd tuple_istuple))
                   (istuple_snd tuple_istuple))
             (istuple_snd tuple_istuple))
        (istuple_fst hashedTa_ext_type_TupleIsom) x;;

let rec prod_case f1 (a, b) = f1 a b;;

let rec hashcodea _A _B
  x = let (a, b) = x in
      Big_int.add_big_int (hashcode _A a) (hashcode _B b);;

let rec hashable _A _B = ({hashcode = hashcodea _A _B} : ('a * 'b) hashable);;

let rec hta_lookup_sf (_A1, _A2) (_B1, _B2)
  q f h =
    hl_idx_lookup (eqc _A1 _B1, hashable _A2 _B2) (q, f) (the (hta_idx_sf h));;

let rec ls_ins_dj x l = x :: l;;

let rec pa_upd_rule (_A1, _A2) (_B1, _B2)
  q w x2 = match q, w, x2 with q, w, [] -> (q, w)
    | q, w, qp :: qs ->
        (if not (hs_memb (eqc _A1 _B1, hashable _A2 _B2) qp q)
          then pa_upd_rule (_A1, _A2) (_B1, _B2)
                 (hs_ins (eqc _A1 _B1, hashable _A2 _B2) qp q) (qp :: w) qs
          else pa_upd_rule (_A1, _A2) (_B1, _B2) q w qs);;

let rec pa_step (_A1, _A2) (_B1, _B2) (_C1, _C2)
  h1 h2 s =
    let (q, (w, delta_d)) = s in
    let (q1, q2) = hd w in
    ls_iterate
      (fun r1 ->
        ls_iterate
          (fun r2 res ->
            (if Big_int.eq_big_int (size_list (rhsq r1)) (size_list (rhsq r2))
              then let rp = r_prod r1 r2 in
                   let (qa, (wa, delta_da)) = res in
                   let (q', w') =
                     pa_upd_rule (_A1, _A2) (_C1, _C2) qa wa (rhsq rp) in
                   (q', (w', ls_ins_dj rp delta_da))
              else res))
          (hta_lookup_sf (_C1, _C2) (_B1, _B2) q2 (rhsl r1) h2))
      (hta_lookup_s (_A1, _A2) q1 h1) (q, (tl w, delta_d));;

let rec map_to_nat
  iterate1 empty2 update2 s =
    snd (iterate1
           (fun x (c, m) ->
             (Big_int.add_big_int c (Big_int.big_int_of_int 1), update2 x c m))
           s
          ((Big_int.big_int_of_int 0), empty2));;

let rec hs_image_filter _A (_B1, _B2)
  = it_image_filter (hs_iterate _A) (hs_empty _B2) (hs_ins (_B1, _B2));;

let rec iflt_image iflt f s = iflt (fun x -> Some (f x)) s;;

let rec hs_image _A (_B1, _B2) = iflt_image (hs_image_filter _A (_B1, _B2));;

let rec hm_update_dj (_A1, _A2) = hm_update (_A1, _A2);;

let rec s_ins_dj update_dj x s = update_dj x () s;;

let rec hs_ins_dj (_A1, _A2) = s_ins_dj (hm_update_dj (_A1, _A2));;

let rec hs_inter (_A1, _A2)
  = it_inter (hs_iterate _A2) (hs_memb (_A1, _A2)) (hs_empty _A2)
      (hs_ins_dj (_A1, _A2));;

let rec s_union add = add;;

let rec hs_union (_A1, _A2) = s_union (hm_add (_A1, _A2));;

let rec hhh_cart (_A1, _A2) (_B1, _B2)
  = cart (hs_iterate _A2) (hs_iterate _B2) (hs_empty (hashable _A2 _B2))
      (hs_ins_dj (eqc _A1 _B1, hashable _A2 _B2));;

let rec brc_cond _A _B = (fun (_, (w, _)) -> not (null w));;

let rec rqrm_lookup (_A1, _A2)
  rqrm q =
    (match hm_lookup (_A1, _A2) q rqrm with None -> ls_empty | Some s -> s);;

let rec hashcode_of_list _A
  = function [] -> (Big_int.big_int_of_int 0)
    | x :: xs -> Big_int.add_big_int (hashcode _A x) (hashcode_of_list _A xs);;

let rec hashcode_list _A = hashcode_of_list _A;;

let rec hashcode_of_ta_rule _A _B
  (Rule (q, f, qs)) =
    Big_int.add_big_int (Big_int.add_big_int (hashcode _A q) (hashcode _B f))
      (hashcode_list _A qs);;

let rec hashcode_ta_rule _A _B = hashcode_of_ta_rule _A _B;;

let rec hashable_ta_rule _A _B =
  ({hashcode = hashcode_ta_rule _A _B} : ('a, 'b) ta_rule hashable);;

let rec brc_inner_step (_A1, _A2) (_B1, _B2)
  r = (fun (q, (w, rcm)) ->
        let c =
          the (hm_lookup (eq_ta_rulea _A1 _B1, hashable_ta_rule _A2 _B2) r rcm)
          in
        let rcm' =
          hm_update (eq_ta_rulea _A1 _B1, hashable_ta_rule _A2 _B2) r
            (minus_nat c (Big_int.big_int_of_int 1)) rcm
          in
        let q' =
          (if Big_int.le_big_int c (Big_int.big_int_of_int 1)
            then hs_ins (_A1, _A2) (lhs r) q else q)
          in
        let w' =
          (if Big_int.le_big_int c (Big_int.big_int_of_int 1) &&
                not (hs_memb (_A1, _A2) (lhs r) q)
            then lhs r :: w else w)
          in
        (q', (w', rcm')));;

let rec brc_step (_A1, _A2) (_B1, _B2)
  rqrm =
    (fun (q, (w, rcm)) ->
      ls_iterate (brc_inner_step (_A1, _A2) (_B1, _B2))
        (rqrm_lookup (_A1, _A2) rqrm (hd w)) (q, (tl w, rcm)));;

let rec brec_iqm (_A1, _A2) _B
  delta =
    ls_iterate
      (fun r m ->
        (if null (rhsq r)
          then hm_update (_A1, _A2) (lhs r) (Node (rhsl r, [])) m else m))
      delta hm_empty;;

let rec build_rule_index_sf (_A1, _A2) (_B1, _B2)
  delta =
    build_rule_index _A1 _B1 (eqc _A1 _B1, hashable _A2 _B2)
      (fun r -> (lhs r, rhsl r)) delta;;

let rec hta_idx_sf_update
  x = comp (istuple_fst_update hashedTa_ext_type_TupleIsom)
        (comp (istuple_snd_update tuple_istuple)
          (comp (istuple_snd_update tuple_istuple)
            (comp (istuple_snd_update tuple_istuple) id)))
        x;;

let rec hta_ensure_idx_sf (_A1, _A2) (_B1, _B2)
  h = (match hta_idx_sf h
        with None ->
          hta_idx_sf_update
            (fun _ ->
              Some (build_rule_index_sf (_A1, _A2) (_B1, _B2) (hta_delta h)))
            h
        | Some _ -> h);;

let rec build_rule_index_s (_A1, _A2) _B
  delta = build_rule_index _A1 _B (_A1, _A2) lhs delta;;

let rec hta_idx_s_update
  x = comp (istuple_fst_update hashedTa_ext_type_TupleIsom)
        (comp (istuple_snd_update tuple_istuple)
          (comp (istuple_snd_update tuple_istuple)
            (comp (istuple_fst_update tuple_istuple) id)))
        x;;

let rec hta_ensure_idx_s (_A1, _A2) _B
  h = (match hta_idx_s h
        with None ->
          hta_idx_s_update
            (fun _ -> Some (build_rule_index_s (_A1, _A2) _B (hta_delta h))) h
        | Some _ -> h);;

let rec curry f a b = f (a, b);;

let rec istuple_cons isom = curry (abst isom);;

let rec hashedTa_ext
  hta_Qi hta_delta hta_idx_f hta_idx_s hta_idx_sf more =
    istuple_cons hashedTa_ext_type_TupleIsom
      (istuple_cons tuple_istuple (istuple_cons tuple_istuple hta_Qi hta_delta)
        (istuple_cons tuple_istuple hta_idx_f
          (istuple_cons tuple_istuple hta_idx_s hta_idx_sf)))
      more;;

let rec init_hta qi delta = hashedTa_ext qi delta None None None ();;

let rec it_set_to_list iterate s = iterate (fun a b -> a :: b) s [];;

let rec hs_to_list _A = it_set_to_list (hs_iterate _A);;

let rec pa_initial (_A1, _A2) _B (_C1, _C2)
  h1 h2 =
    let qip = hhh_cart (_A1, _A2) (_C1, _C2) (hta_Qi h1) (hta_Qi h2) in
    (qip, (hs_to_list (hashable _A2 _C2) qip, ls_empty));;

let rec whilea b c s = (if b s then whilea b c (c s) else s);;

let rec hta_prod' (_A1, _A2) (_B1, _B2) (_C1, _C2)
  h1 h2 =
    let (_, (_, a)) =
      whilea (pa_cond _A2 _C2 _B2)
        (pa_step (_A1, _A2) (_B1, _B2) (_C1, _C2) h1 h2)
        (pa_initial (_A1, _A2) _B2 (_C1, _C2) h1 h2)
      in
    init_hta (hhh_cart (_A1, _A2) (_C1, _C2) (hta_Qi h1) (hta_Qi h2)) a;;

let rec hta_prod (_A1, _A2) (_B1, _B2) (_C1, _C2)
  h1 h2 =
    hta_prod' (_A1, _A2) (_B1, _B2) (_C1, _C2)
      (hta_ensure_idx_s (_A1, _A2) _B1 h1)
      (hta_ensure_idx_sf (_C1, _C2) (_B1, _B2) h2);;

let rec hashcode_nat i = i;;

let hashable_nat = ({hashcode = hashcode_nat} : Big_int.big_int hashable);;

let rec htai_mem x = hta_mem (eq_nat, hashable_nat) (eq_nat, hashable_nat) x;;

let rec rqrm_add (_A1, _A2) _B
  q r res =
    (match hm_lookup (_A1, _A2) q res
      with None -> hm_update (_A1, _A2) q (ls_ins _B r ls_empty) res
      | Some s -> hm_update (_A1, _A2) q (ls_ins _B r s) res);;

let rec fifo_isEmpty _A f = eqb (eq_lista _A) (eq_lista _A) f ([], []);;

let rec lhh_union (_A1, _A2) = it_union ls_iterate (hs_ins (_A1, _A2));;

let rec brec_cond _A
  = (fun (_, (w, (_, qwit))) -> not (fifo_isEmpty _A w) && is_none qwit);;

let rec brec_construct_witness (_A1, _A2) _B
  qm r =
    Node (rhsl r, map (fun q -> the (hm_lookup (_A1, _A2) q qm)) (rhsq r));;

let rec brec_inner_step (_A1, _A2) (_B1, _B2)
  qi r =
    (fun (q, (w, (rcm, qwit))) ->
      let c =
        the (hm_lookup (eq_ta_rulea _A1 _B1, hashable_ta_rule _A2 _B2) r rcm) in
      let cond =
        Big_int.le_big_int c (Big_int.big_int_of_int 1) &&
          is_none (hm_lookup (_A1, _A2) (lhs r) q)
        in
      let rcm' =
        hm_update (eq_ta_rulea _A1 _B1, hashable_ta_rule _A2 _B2) r
          (minus_nat c (Big_int.big_int_of_int 1)) rcm
        in
      let q' =
        (if cond
          then hm_update (_A1, _A2) (lhs r)
                 (brec_construct_witness (_A1, _A2) _B2 q r) q
          else q)
        in
      let w' = (if cond then fifo_put (lhs r) w else w) in
      let qwit' =
        (if Big_int.le_big_int c (Big_int.big_int_of_int 1) &&
              hs_memb (_A1, _A2) (lhs r) qi
          then Some (lhs r) else qwit)
        in
      (q', (w', (rcm', qwit'))));;

let rec brec_step (_A1, _A2) (_B1, _B2)
  rqrm qi =
    (fun (q, (w, (rcm, qwit))) ->
      let (qa, w') = fifo_get w in
      ls_iterate (brec_inner_step (_A1, _A2) (_B1, _B2) qi)
        (rqrm_lookup (_A1, _A2) rqrm qa) (q, (w', (rcm, qwit))));;

let rec hta_empty _A _B = init_hta (hs_empty _A) ls_empty;;

let rec ls_image _B = iflt_image (ls_image_filter _B);;

let rec hta_remap _A (_B1, _B2) (_C1, _C2)
  f h = init_hta (hs_image _A (_B1, _B2) f (hta_Qi h))
          (ls_image (eq_ta_rulea _B1 _C1) (remap_rule f) (hta_delta h));;

let rec ls_union_dj s1 s2 = revg s1 s2;;

let rec hashcode_of_usw _A _B
  = function USW1 q -> hashcode _A q
    | USW2 q -> hashcode _B q;;

let rec hashcode_ustate_wrapper _A _B = hashcode_of_usw _A _B;;

let rec hashable_ustate_wrapper _A _B =
  ({hashcode = hashcode_ustate_wrapper _A _B} :
    ('a, 'b) ustate_wrapper hashable);;

let rec eq_ustate_wrapper _A _B
  x0 x1 = match x0, x1 with USW1 q1, USW1 q1' -> eqa _A q1 q1'
    | USW2 q2, USW2 q2' -> eqa _B q2 q2'
    | USW1 q1, USW2 q2' -> false
    | USW2 q2', USW1 q1 -> false;;

let rec eq_ustate_wrappera _A _B =
  ({eq = eq_ustate_wrapper _A _B} : ('a, 'b) ustate_wrapper eq);;

let rec hta_union (_A1, _A2) (_B1, _B2) (_C1, _C2)
  h1 h2 =
    init_hta
      (hs_union (eq_ustate_wrappera _A1 _C1, hashable_ustate_wrapper _A2 _C2)
        (hs_image _A2
          (eq_ustate_wrappera _A1 _C1, hashable_ustate_wrapper _A2 _C2)
          (fun a -> USW1 a) (hta_Qi h1))
        (hs_image _C2
          (eq_ustate_wrappera _A1 _C1, hashable_ustate_wrapper _A2 _C2)
          (fun a -> USW2 a) (hta_Qi h2)))
      (ls_union_dj
        (ls_image (eq_ta_rulea (eq_ustate_wrappera _A1 _C1) _B1)
          (remap_rule (fun a -> USW1 a)) (hta_delta h1))
        (ls_image (eq_ta_rulea (eq_ustate_wrappera _A1 _C1) _B1)
          (remap_rule (fun a -> USW2 a)) (hta_delta h2)));;

let rec list_to_ls _A = remdups _A;;

let rec rule_states_l _A (Rule (q, f, qs)) = ls_ins _A q (list_to_ls _A qs);;

let rec it_Union_image it1 em3 un233 f s = it1 (fun x -> un233 (f x)) s em3;;

let rec llh_Union_image (_B1, _B2)
  = it_Union_image ls_iterate (hs_empty _B2) (lhh_union (_B1, _B2));;

let rec hta_delta_states (_A1, _A2)
  h = llh_Union_image (_A1, _A2) id
        (ls_image_filter (eq_lista _A1) (fun r -> Some (rule_states_l _A1 r))
          (hta_delta h));;

let rec hta_states (_A1, _A2)
  h = hs_union (_A1, _A2) (hta_Qi h) (hta_delta_states (_A1, _A2) h);;

let rec hh_map_to_nat (_A1, _A2)
  = map_to_nat (hs_iterate _A2) hm_empty (hm_update (_A1, _A2));;

let rec hta_reindex (_A1, _A2) (_B1, _B2)
  h = let mp = hh_map_to_nat (_A1, _A2) (hta_states (_A1, _A2) h) in
      hta_remap _A2 (eq_nat, hashable_nat) (_B1, _B2)
        (fun q -> the (hm_lookup (_A1, _A2) q mp)) h;;

let rec htai_prod
  h1 h2 =
    hta_reindex (eqc eq_nat eq_nat, hashable hashable_nat hashable_nat)
      (eq_nat, hashable_nat)
      (hta_prod (eq_nat, hashable_nat) (eq_nat, hashable_nat)
        (eq_nat, hashable_nat) h1 h2);;

let rec length_unique _A
  = function [] -> (Big_int.big_int_of_int 0)
    | x :: xs ->
        (if member _A x xs then length_unique _A xs
          else suc (length_unique _A xs));;

let rec rs_iterate _A = s_iterate (rm_iterate _A);;

let rec rs_size _A = it_size (rs_iterate _A);;

let rec it_set_to_fifo iterate s = iterate fifo_put s fifo_empty;;

let rec hs_to_fifo _A = it_set_to_fifo (hs_iterate _A);;

let rec build_rqrm (_A1, _A2) (_B1, _B2)
  delta =
    ls_iterate
      (fun r res ->
        foldl (fun resa q -> rqrm_add (_A1, _A2) (eq_ta_rulea _A1 _B1) q r resa)
          res (rhsq r))
      delta hm_empty;;

let rec hta_add_qi (_A1, _A2) _B
  qi h = init_hta (hs_ins (_A1, _A2) qi (hta_Qi h)) (hta_delta h);;

let rec lll_inj_image_filter_cp
  x = inj_image_filter_cp ls_iterate ls_iterate ls_empty ls_ins_dj x;;

let rec delta_prod_h _A (_B1, _B2) _C
  delta_1 delta_2 =
    lll_inj_image_filter_cp r_prod
      (fun r1 r2 ->
        eqa _B1 (rhsl r1) (rhsl r2) &&
          Big_int.eq_big_int (size_list (rhsq r1)) (size_list (rhsq r2)))
      delta_1 delta_2;;

let rec hta_prodWR (_A1, _A2) (_B1, _B2) (_D1, _D2)
  h1 h2 =
    init_hta (hhh_cart (_A1, _A2) (_D1, _D2) (hta_Qi h1) (hta_Qi h2))
      (delta_prod_h _A2 (_B1, _B2) _D2 (hta_delta h1) (hta_delta h2));;

let rec hta_reduce (_A1, _A2) _B
  h q = init_hta (hs_inter (_A1, _A2) q (hta_Qi h))
          (ls_image_filter (eq_ta_rulea _A1 _B)
            (fun r ->
              (if hs_memb (_A1, _A2) (lhs r) q &&
                    list_all (fun qa -> hs_memb (_A1, _A2) qa q) (rhsq r)
                then Some r else None))
            (hta_delta h));;

let htai_empty : (Big_int.big_int, Big_int.big_int, unit) hashedTa_ext_type
  = hta_empty hashable_nat hashable_nat;;

let rec htai_union
  h1 h2 =
    hta_reindex
      (eq_ustate_wrappera eq_nat eq_nat,
        hashable_ustate_wrapper hashable_nat hashable_nat)
      (eq_nat, hashable_nat)
      (hta_union (eq_nat, hashable_nat) (eq_nat, hashable_nat)
        (eq_nat, hashable_nat) h1 h2);;

let rec ls_size x = it_size ls_iterate x;;

let rec brc_rcm_init (_A1, _A2) (_B1, _B2)
  delta =
    ls_iterate
      (fun r ->
        hm_update (eq_ta_rulea _A1 _B1, hashable_ta_rule _A2 _B2) r
          (length_unique _A1 (rhsq r)))
      delta hm_empty;;

let rec brc_initial (_A1, _A2) (_B1, _B2)
  delta =
    let iq = brc_iq (_A1, _A2) delta in
    (iq, (hs_to_list _A2 iq, brc_rcm_init (_A1, _A2) (_B1, _B2) delta));;

let rec htai_add_qi x = hta_add_qi (eq_nat, hashable_nat) hashable_nat x;;

let rec htai_prodWR
  h1 h2 =
    hta_reindex (eqc eq_nat eq_nat, hashable hashable_nat hashable_nat)
      (eq_nat, hashable_nat)
      (hta_prodWR (eq_nat, hashable_nat) (eq_nat, hashable_nat)
        (eq_nat, hashable_nat) h1 h2);;

let rec sel_disjoint_witness
  sel1 mem2 s1 s2 = sel1 s1 (fun x -> (if mem2 x s2 then Some x else None));;

let rec hh_disjoint_witness (_A1, _A2)
  = sel_disjoint_witness (hs_sel _A2) (hs_memb (_A1, _A2));;

let rec brec_initial (_A1, _A2) (_B1, _B2)
  qi delta =
    let iq = brc_iq (_A1, _A2) delta in
    (brec_iqm (_A1, _A2) _B2 delta,
      (hs_to_fifo _A2 iq,
        (brc_rcm_init (_A1, _A2) (_B1, _B2) delta,
          hh_disjoint_witness (_A1, _A2) iq qi)));;

let rec hta_add_rule (_A1, _A2) (_B1, _B2)
  r h = init_hta (hta_Qi h) (ls_ins (eq_ta_rulea _A1 _B1) r (hta_delta h));;

let rec htai_add_rule
  x = hta_add_rule (eq_nat, hashable_nat) (eq_nat, hashable_nat) x;;

let rec hta_bwd_reduce (_A1, _A2) (_B1, _B2)
  h = let rqrm = build_rqrm (_A1, _A2) (_B1, _B2) (hta_delta h) in
      hta_reduce (_A1, _A2) _B1 h
        (fst (whilea (brc_cond _A2 _B2) (brc_step (_A1, _A2) (_B1, _B2) rqrm)
               (brc_initial (_A1, _A2) (_B1, _B2) (hta_delta h))));;

let rec htai_bwd_reduce
  x = hta_bwd_reduce (eq_nat, hashable_nat) (eq_nat, hashable_nat) x;;

let rec htai_ensure_idx_f x = hta_ensure_idx_f eq_nat (eq_nat, hashable_nat) x;;

let rec htai_ensure_idx_s x = hta_ensure_idx_s (eq_nat, hashable_nat) eq_nat x;;

let rec htai_ensure_idx_sf
  x = hta_ensure_idx_sf (eq_nat, hashable_nat) (eq_nat, hashable_nat) x;;

let rec hta_is_empty_witness (_A1, _A2) (_B1, _B2)
  h = let rqrm = build_rqrm (_A1, _A2) (_B1, _B2) (hta_delta h) in
      (match
        whilea (brec_cond _A1) (brec_step (_A1, _A2) (_B1, _B2) rqrm (hta_Qi h))
          (brec_initial (_A1, _A2) (_B1, _B2) (hta_Qi h) (hta_delta h))
        with (q, (_, (_, None))) -> None
        | (q, (_, (_, Some qa))) -> hm_lookup (_A1, _A2) qa q);;

let rec htai_is_empty_witness
  x = hta_is_empty_witness (eq_nat, hashable_nat) (eq_nat, hashable_nat) x;;

end;; (*struct Ta*)
